<?php

namespace Cacic\CommonBundle\Entity;

use Doctrine\ORM\EntityRepository;

use Cacic\CommonBundle\Entity\TipoSo;

/**
 * TipoSoRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TipoSoRepository extends EntityRepository
{
    /**
     * Paginar
     *
     * @param \Knp\Component\Pager\Paginator $paginator
     * @param int $page
     * @return \Knp\Component\Pager\Pagination\PaginationInterface
     */
    public function paginar( \Knp\Component\Pager\Paginator $paginator, $page = 1 )
    {
        $_dql = "SELECT s
				FROM CacicCommonBundle:TipoSo s
				ORDER BY s.tipo";

        return $paginator->paginate(
            $this->getEntityManager()->createQuery( $_dql ),
            $page,
            10
        );
    }

    /**
     *
     * Método de listagem dos Tipo de Software cadastrados e respectivas informações
     */
    public function listar()
    {
        $_dql = "SELECT s
				FROM CacicCommonBundle:TipoSo s
				ORDER BY s.tipo";

        return $this->getEntityManager()->createQuery( $_dql )->getArrayResult();
    }

    /**
     * Insere tipo de SO
     *
     * @param $te_so
     * @return TipoSo|null|object
     */

    public function createIfNotExist( $te_so )
    {
        $so = $this->findOneBy( array ( 'tipo' => $te_so ) );

        if( empty( $so ) )
        {
            $so = new TipoSo();

            $so->setTipo($te_so);
            $this->getEntityManager()->persist( $so );
            $this->getEntityManager()->flush();

        }

        return $so;

    }

}
